//
// This is a helper module for creating P*M files (a very simple image
// file format.
//
use MPlot;

//
// Dimensions of the image file in pixels
//
config const rows = 201,
             cols = rows;

//
// Maximum number of steps to iterate before giving up
//
config const maxSteps = 20;


proc main() {
  //
  // TODO: Declare NumSteps to be an array of rows x cols ints to
  // serve as your virtual image map.  You may wish to declare a named
  // domain for it as well.
  //

  //
  // TODO: Call coordToNumSteps() for each index within the NumSteps
  // array to calculate the number of steps required to converge from
  // 0 to maxSteps for that pixel.

  //
  // Plot the image
  //
  plot(NumSteps, 
       /* TODO: add a second argument indicating the largest value in NumSteps,
          in the event that no computations took maxSteps */
      );
}


// =========================================================================
// HELPER FUNCTIONS (should not require modification unless you want to zoom
// in on the Mandelbrot image, change the computation, etc.)
//

//
// Given a coordinate in the space (0..#rows, 0..#cols), compute the
// number of steps required to converge
//
proc coordToNumSteps((x, y)) {
  const c = mapImg2CPlane((x, y));
  
  var z: complex;
  for i in 1..maxSteps {
    z = z*z + c;
    if (abs(z) > 2.0) then
      return i;
  }
  return 0;			
}


//
// Map an image coordinate to a point in the complex plane.
// Image coordinates are (row, col), with row 0 at the top.
//
proc mapImg2CPlane((row, col)) {
  const (rmin, rmax) = (-1.5, .5);
  const (imin, imax) = (-1i, 1i);

  return ((rmax - rmin) * col / cols + rmin) +
         ((imin - imax) * row / rows + imax);
}

